' GetTVDK version 5.6.1               
' Dette script henter TV Guiden fra tv2.dk
'
' Den laver en rkke filer i dit samurize bibliotek i folderen "TvGuides" for hver af de tv kanaler du henter (fx Dr1.txt)
' Giver scriptet nogenside fejl, s prv fst at slette folderen og kr script igen, fr du sger hjlp
'
' Fejl, mangler og optimeringers forslag bedes sende til: limdul@samurize.com
' Hvis du ndrer i scriptet s send mig venligt den ndrede version, samt lad denne tekst st.
'
' Scriptet er laver af LimDul og er en ndret udgave af GetTVDK_2 script lavet af Soeren The Cool
' som lavede et totalt omskrevet script ud fra det orginale GetTVDK script laver af LimDul.
' Progressbar support laver udfra kode skrevet af rekoj & starv.
'
' Modificeret af LuxAeterna til at hente programoversigten fra TV2.dk i stedet for TDCkabeltv.
' I processen rg flg. kanaler: 3PLUS, BBCFood, CPLUSFILM2, CMOREFILM, CPLUSSPORT, RTK1, CNBC, CIVILIZATION,
' SCIENCE, TRAVEL, FOXKIDS (desvrre), MTV2 og NDR. Til gengld er HALLMARK kommet p sammen med KANALKBH.
' Har derudover optimeret koden og rettet en rkke fejl, f.eks. viste scriptet ikke dagens sidste program.
' Kommentarer omkring denne version kan sendes til martin.kock@mail.dk.
'
' Version 1	    - Af LimDul (C)14.03.03
' Version 2	    - Af Soeren The Cool (C) 31.08.02
' Version 3	    - Af LimDul udfra Version 2 lavet af Soeren The Cool
' Version 4         - Af LimDul med hjlp fra AdamC og med code fra NeM
' Version 4.2.1     - Bugfix i ErTVGuideHentet() funktionen - Soeren The Cool ;-)
' Version 5         - Af LimDul med kode fra Tosius's Weather 2003 Pro script
' Version 6	    - Af LuxAeterna, september 2004
'
'					Ls ReadMe.txt for en vejledning i hvordan du bruger scriptet!

	
'Indstillinger - st dem s de passer dig
showStation = 0					        ' Skal stationsnavnet vises ved det nuvrende program (1=ja 0=nej)
showTime = 1						' Skal tiden vises ved det nuvrende program (1=ja 0=nej)
showEndTime  = 0
timeDelimiter = ":"					' Hvad skal adskille timer og minutter [fx 14:23] (standart ":")
stationTimeSeparator = " "				' Hvad skal adskille stadion navnet og program tiden (bruges kun hvis begge er slet til) (standart " ")
timeProgramSeparator = " "				' Hvad skal adskille program tiden og programmet (bruges kun hvis begge er slet til) (standart " ")
stationProgramSeparator = ": "				' Hvad skal adskille stations navnet og programmet (bruges hvis kun stadions navn er slet til) (standart ": ")
TVGuideFolder = "TVGuides"				' Navnet p den folder som GetTV skal hente programoversiterne i
TV2 = "http://tv.tv2.dk"				' Siden til TV2 Kabel TV (har det med at blive ndret af TV2)
IkonSti = "skins\TVIkoner"				' Hvor du har dine TV ikoner liggende ("skins\TVIkoner\Round" er standart)

'Beskeder - ret selv hvis du vil
noNextProgram = "Ingen nste udsendelse"  		' Besked hvis der ikke er noget nste program 
noCurrentProgram = "Sender ikke nu" 	    		' Besked hvis der ikke er noget program lige nu
noTVGuide = "Ingen programoversigt!"      		' Besked hvis TVguiden ikke findes (fejl...)
waitingForTVGuide = "Venter p ny programoversigt..." 	' Besked mens scriptet venter p en ny programoversigt
gettingForTVGuide = "Henter ny programoversigt..." 	' Besked mens scriptet er ved at hente programoversigten
ForkertKanalID = "Forkert Kanal Navn"			' Besked hvis det indtastede kanal navn ikke findes


'S skal du ikke pille ved mere, herunder!
'S skal du ikke pille ved mere, herunder!


'Tags (pil ikke ved dem!)
SPANTag = "<span"
SPANEndTag = "</span>"	
DIVTag = "<div"


Function Programoversigt(Kanal,Nummer)

	Dim sourceUrl, tempUrl

	tempUrl = TV2 & "/tv/listning.php?Region=1&Kategori=0&Dato=0&Soegeord=&Periode=2&KanalID="
	
	fileName = GetTempPath & "TVGuide_" & Kanal & ".txt"
	Set fs=CreateObject("Scripting.FileSystemObject")

	If ID(Kanal) <> "ERROR" Then
		If Nummer = 0 Then

			If (fs.FileExists(filename)) Then
			'Check dato
				If ErGuideNy(Kanal) <> 1 Then
					sourceUrl = tempUrl & ID(Kanal)
					LoadTVToFile Kanal, sourceUrl
				End If
			Else
				sourceUrl = tempUrl & ID(Kanal)
				LoadTVToFile Kanal, sourceUrl
			End If

			set f = fs.OpenTextFile (fileName,1)
			tekst = f.readall
			f.close
			Set f=nothing
			If InStr (tekst, "==") > 0 Then
				result = FindProgram (Kanal, tekst, Nummer)
			Else
				result = noTVGuide
			End If

		Else
			If (fs.FileExists(filename)) Then

				set f = fs.OpenTextFile (fileName,1)
				tekst = f.readall
				f.close
				Set f=nothing
				If InStr (tekst, "==") > 0 Then
					result = FindProgram (Kanal, tekst, Nummer)
				Else
					result = noTVGuide
				End If
			Else
				result = waitingForTVGuide
			End If
		End If

		Programoversigt = result & "%lhttp://tv.tv2.dk/tv/?Region=1&Kategori=0&Dato=0&Soegeord=&Periode=0&KanalID=" & ID(Kanal)
	Else
		Programoversigt = ForkertKanalID
	End If

End Function


Function Timebar(Kanal,Enhed)

	'Set Some variables to ensure that Station isnt shown and end time is
	showStation = 0
	showEndTime = 1
	
	fileName = GetTempPath & "TVGuide_" & Kanal & ".txt"
	Set fs=CreateObject("Scripting.FileSystemObject")
	
	If ID(Kanal) <> "ERROR" Then
		If (fs.FileExists(filename)) Then
			If ErGuideNy(Kanal) = 1 Then
	
				result = CompareTime(Left(FindProgressbar(Kanal),5),Left(FindProgressbar(Kanal),11),Enhed)
			Else
				result = NoTVGuide
			End If
		Else
			result = waitingForTVGuide
		End If
	Else
		result = ForkertKanalID
	End If	
	
	Timebar = result		

End Function


Function Ikon(Kanal, Form)

	SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
	Set fso=CreateObject("Scripting.FileSystemObject")

	If ID(Kanal) <> "ERROR" Then
		sti = SamurizeDir & IkonSti
		If Form = "firkants" Then
			sti2 = "Square"
		Else
			sti2 = "Round"
		End If
		Ikon = sti & "\" & sti2 & "\" & kanal & ".png"
	Else
		Ikon = "Forkert Kanalnavn"
	End If

End Function


Private Function FindProgressbar(Kanal)

	Nummer = 0

	Dim sourceUrl, tempUrl
	tempUrl = TV2 & "/tv/listning.php?Region=1&Kategori=0&Dato=0&Soegeord=&Periode=2&KanalID="
	
	fileName = GetTempPath & "TVGuide_" & Kanal & ".txt"
	Set fs=CreateObject("Scripting.FileSystemObject")

	Set f = fs.OpenTextFile (fileName,1)
	tekst = f.readall
	f.close
	Set f=nothing
	If InStr (tekst, "==") > 0 Then
		result = FindProgram (Kanal, tekst, Nummer)
	Else
		result = noTVGuide
	End If
		
	FindProgressbar = result
	
End Function


Private Function ErGuideNy(Kanal)

	Dim fs, f, result, filename
	Dim dato, idag
	
	fileName = GetTempPath & "TVGuide_" & Kanal & ".txt"

	set fs=CreateObject("Scripting.FileSystemObject")
	If (fs.FileExists (fileName)) Then
		dato = DateLastModified(Kanal)
		result = 1
	Else
		result = 0
	End If
	
	idag = Date
	
	If result = 1 Then
		If DateDiff("d", dato, idag) > 1 Then
			'If more than 1 day old always load new guide
			result = 0
		End If
		If DateDiff("d", dato, idag) = 1 And DateDiff("h", Tidsomregner, "05:00") < 0 Then
			'If less than 1 day old, only load guide if time is later than 5 am
			result = 0
		End If
	End If
	
	ErGuideNy = result
		
End Function


Private Function Tidsomregner

	Tid = Time
	Tidsomregner = FormatDateTime(Tid,4)

End Function


Private Function ID(Kanal)

	Dim KanalStor
	
	KanalStor = UCase(Kanal)

	' TILFJ DINE EGNE KANALER HER!!!
	' OBS KANALNAVN SKAL VRE MED STORT!!!

	Select Case KanalStor
	
		Case "ANIMAL"		ID = "36"	' Finder kanal Id
		Case "ARD"		ID = "55"
		Case "ARTE"		ID = "56"
		Case "BBCPRIME"		ID = "37"
		Case "BBCWORLD"		ID = "38"
		Case "CPLUS"		ID = "9"
		Case "CPLUSFILM1"	ID = "10"
		Case "CARTOON"		ID = "39"
		Case "CINEMA"		ID = "12"
		Case "CNN"		ID = "40"
		Case "DISCOVERY"	ID = "41"
		Case "DK4"		ID = "14"
		Case "DR1"		ID = "3"
		Case "DR2"		ID = "4"
		Case "EUROSPORT"	ID = "13"
		Case "HALLMARK"		ID = "98"
		Case "KANAL5"		ID = "7"
		Case "KANALKBH"		ID = "109"
		Case "MTV"		ID = "42"
		Case "NATIONALGEOGRAPHIC" ID = "43"
		Case "NRK1"		ID = "31"
		Case "RTL"		ID = "61"
		Case "SAT1"		ID = "63"
		Case "STV"		ID = "64"
		Case "SVERIGE1"		ID = "24"
		Case "SVERIGE2"		ID = "25"
		Case "TCM"		ID = "101"
		Case "TRAVELCHANNEL"	ID = "51"
		Case "TV2"		ID = "1"
		Case "TV2NORGE"		ID = "33"
		Case "ZULU"		ID = "2"
		Case "TV3"		ID = "6"
		Case "TV3PLUS"		ID = "5"
		Case "TV4"		ID = "27"
		Case "TV5"		ID = "69"
		Case "TV6"		ID = "29"
		Case "TV1000"		ID = "11"
		Case "TVDK"		ID = "8"
		Case "VH1"		ID = "52"
		Case "VIASATSPORT"	ID = "149"
		Case "VIASP"		ID = "149"
		Case "VIASP1"		ID = "149"
		Case "VOX"		ID = "65"
		Case "ZDF"		ID = "66"
		Case Else       	ID = "ERROR"
	End Select
 
End Function


Private Function GetTempPath

	Dim SamurizeDir

	SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
	Set fso=CreateObject("Scripting.FileSystemObject")

	GetTempPath = SamurizeDir & TVGuideFolder & "\" 
	If Not fso.FolderExists(GetTempPath) Then 
  		fso.CreateFolder(GetTempPath)
 	End If
 	
End Function


Private Function LoadTVToFile (channel, sourceUrl)
	
	Dim html, fs, f, filename, SamurizeDir
	
	filename = GetTempPath & "TVGuide_" & channel & ".temp"
	Set fs=CreateObject("Scripting.FileSystemObject")
	
	url = sourceUrl
	
	html = BinToText(GetHTMLBin (url), 35000)
	If (fs.FileExists (fileName)) Then
		'Append to file
		set f = fs.OpenTextFile (filename, 8)
	Else
		set f = fs.CreateTextFile (filename, true)
	End If
	f.write (html)
	f.close
	ExtractProgramInfo channel, fileName
	Set fs=nothing

End Function


Private Function ExtractProgramInfo (channel, tempFilename)

	Dim html, fs, fileName

	fileName = GetTempPath & "TVGuide_" & channel & ".txt"
	Set fs=CreateObject("Scripting.FileSystemObject") 

	if(fs.FileExists(tempFilename)) then
		Dim f
		set f=fs.OpenTextFile(tempFileName,1)
		html = f.readall
		f.close
		set f=nothing

	Else
		html = "   "
	end if

	'Make the file to the program
	set f = fs.CreateTextFile(fileName,true)

	'Then we find the programs.
	Do
		html = GetProgram (html, f)
	loop until InStr (html, "<div class='udsendelse'>") = 0
 
 	f.close
	
	'Delete the temp file again
	fs.DeleteFile(tempFilename)
 	set fs=nothing
 	
End Function


Private Function GetProgram (html, fo)
	
	Dim start, slut, program, result, html2, tempStartPos, tempEndPos

	'Each program with info is slipt on 3 or 4 rows in the tabel
	'In the second is the time from - to (2. celle) and programname (4. celle)
	'In hte 3th is the type (comedy/news and such) (4. celle)
	'Row 1 (and 4 if it's there) we don't need.

	'Test whether there are any programs at all
	If InStr(html, "Der blev ikke fundet nogen udsendelser.") Then
		fo.write(" ")
		GetProgram = ""
	Else

		'Find the start time
		html = RemoveToDIV (html)
		html = RemoveToDIV (html)
		html = RemoveToSPAN (html)
		start = Left(html, 5)

		'Find the program name
		html = RemoveToSPAN(html)
		tempEndPos = InStr(html, SPANEndTag)
		program = Left(html, tempEndPos-1)

		'Remove rest of _program_ html code
		tempStartPos = InStr(html, "<div class='udsendelse'>")
		html = Right(html, Len(html)-tempStartPos+1)

		'Find the end time (start time of next program)
		'This must be done without altering the original html variable
		html2 = html
		html2 = RemoveToDIV(html2)
		html2 = RemoveToDIV(html2)
		html2 = RemoveToSPAN(html2)
		slut = Left(html2, 5)

		'We may not know the end time of the program. If we don't, make sure
		'the user knows, and set a new end time of +2hrs so the user can see it
		If IsNumeric(Left(slut, 2)) = False And IsNumeric(Right(slut, 2)) = False Then
			slut = (CInt(Left(start, 2))+2) & Right(start, 3)
			program = program & " (Ukendt sluttid)"
		End if
		'Write result to file
		result = "==" & start & "#" &slut & "#" & program & "#"
		fo.write (result)

		GetProgram = html
	End If
	
End Function


Private Function RemoveToDIV (tHtml)

	Dim tempStartPos
	
	tempStartPos = instr(tHtml, DIVTag)
	tHtml = Right (tHtml, Len(tHtml) - tempStartPos)	
	tempStartPos = instr(tHtml, ">")
	tHtml = Right (tHtml, Len(tHtml) - tempStartPos)	
	RemoveToDIV = tHtml

End Function


Private Function RemoveToSPAN (tHtml)

	Dim tempStartPos
	
	tempStartPos = instr(tHtml, SPANTag)
	tHtml = Right (tHtml, Len(tHtml) - tempStartPos)	
	tempStartPos = instr(tHtml, ">")
	tHtml = Right (tHtml, Len(tHtml) - tempStartPos)	
	RemoveToSPAN = tHtml

End Function


Private Function FindProgram (channel, tekst, getNext)

	Dim tid, tidligsteStart, foundFirstProgram, foundProgram
	Dim tempStartPos, i, start1, slut1, program1, start, slut, program, result

	'Actual time
	tid = Tidsomregner
	tid = Left (tid, 5)
	
	tidligsteStart = start
	foundFirstProgram = 0

	Do
		'Start by finding begining and end time for the program (slut=end in Danish)
		tempStartPos = InStr (tekst, "==")
		tempStartPos = tempStartPos + 1

		'If no program was found
		if tempStartPos = 1 then
			exit do
		end if

		'Find begining time for the program
		tempStartPos = InStr (tekst, "==")
		tempStartPos = tempStartPos + 1
		tekst = Right (tekst, (Len (tekst) - tempStartPos))
		start1 = Left (tekst, 5)

		'Find ending time for the program
		tempStartPos = InStr (tekst, "#")
		tekst = Right (tekst, (Len (tekst) - tempStartPos))
		slut1 = Left (tekst, 5)

		'Find the program name
		tempStartPos = InStr (tekst, "#")
		tekst = Right (tekst, (Len (tekst) - tempStartPos))
		tempStartPos = InStr (tekst, "#")
		program1 = Left (tekst, tempStartPos-1)

		'Remove end symbol
		tempStartPos = InStr(tekst, "#")
		tekst = Right(tekst, Len(tekst)-tempStartPos)

		If ((tid >= start1 and tid <= slut1) or (tid >= start1 and slut1 < start1) or (tid <= start1 and slut1 < start1 and tid < slut1)) Then
			'First Program Found
			foundFirstProgram = 1
		End If

	Loop until foundFirstProgram = 1
	
	If getNext > 0 Then
		foundProgram = 1

		if foundFirstProgram = 1 then
			for i = 0 to getNext-1
				result = ""

				'Start by checking if there are more programs
				tempStartPos = InStr (tekst, "==")
				If tempStartPos = 0 Then
					foundProgram = 0
					Exit for
				End if

				'Find begining time for the program
				tempStartPos = tempStartPos + 1
				tekst = Right (tekst, (Len (tekst) - tempStartPos))
				start = Left (tekst, 5)

				'Find ending time for the program
				tempStartPos = InStr (tekst, "#")
				tekst = Right (tekst, (Len (tekst) - tempStartPos))
				slut = Left (tekst, 5)

				'Find the program name
				tempStartPos = InStr (tekst, "#")
				tekst = Right (tekst, (Len (tekst) - tempStartPos))
				tempStartPos = InStr (tekst, "#")
				program = Left (tekst, tempStartPos-1)

				'Remove clutter
				tempStartPos = InStr(tekst, "#")
				tekst = Right(tekst, Len(tekst)-tempStartPos)
				
				result = MakeProgString(channel, start, slut, program)
			next
		End If
	End if
	
	'Collect results and generate program string
	If foundFirstProgram = 1 Then
		If getNext = 0 Then
			result = MakeProgString(channel, start1, slut1, program1)
		Else
			If foundProgram = 1 Then
				result = result
			Else
				result = noNextProgram
			End if
		End if
	Else
		result = noCurrentProgram
	End if

	FindProgram = result

End Function


Private Function MakeProgString (channel, start, finish, program)

	Dim result
	
	If (showStation = 1) then
		if (showTime = 1) then
			result = channel & stationTimeSeparator
		else
			result = channel & stationProgramSeparator
		end if
	end if
	if (showTime = 1) then
		if (showEndTime = 1) then
			result = result & start & "-" & finish
		Else
			result = result & start
		End If
	end if

	MakeProgString = result & " " & program

End Function


Private Function CompareTime(intTimeA,intTimeB,Enhed)

	Dim StartHour, StartMinute, EndHour, EndMinute, ShowLength, ShowPos, Procent
	Dim Minutes, length_totalmin, length_hours, length_hours2, length_min, result

	If instr(intTimeA, "Send") <> 0 OR instr(intTimeB, "Send") then
		CompareTime = 0
	Else
		intTimeB = Mid(intTimeB, InStr(intTimeB, "-")+1)

		'Get Start Times
		StartHour = Left(intTimeA, 2)
		StartMinute = Right(intTimeA, 2)
		
		'Get End Times
		EndHour   = Left(intTimeB, 2)
		EndMinute = Right(intTimeB, 2)

		' Thanks to NeM for parts of this section, changed a few bits so that it should work correctly over the 12.00am
		' Wraparound time fix
		If (CInt(EndHour)*60 + CInt(EndMinute)) < (CInt(StartHour)*60 + CInt(StartMinute)) Then
			EndHour = EndHour + 24
		End If
		
        	ShowLength = (CInt(EndHour)*60 + Cint(EndMinute))  - (CInt(StartHour)*60 + Cint(StartMinute))
	
		If (CInt(Hour(Time)*60 + Minute(Time)) < (CInt(StartHour)*60 + Cint(StartMinute))) Then
			StartHour = StartHour - 24
		End If 
	
		ShowPos = Hour(Time)*60 + Minute(Time) - (CInt(StartHour)*60 + Cint(StartMinute))
		
		Procent = ShowPos / ShowLength * 100
		Minutes = ShowLength - ShowPos & " min"
		
		length_totalmin = ShowLength - ShowPos 
		length_hours 	= length_totalmin / 60
		length_hours2 	= Int(length_hours)
		length_min  	= length_totalmin MOD 60
		
		If length_hours2 > 1 AND length_min > 1 Then
			Minutes = length_hours2 & " timer og " & length_min & " minutter tilbage"
		ElseIf length_hours2 > 1 AND length_min = 1  Then
			Minutes = length_hours2 & " timer og " & length_min & " minut tilbage"
		ElseIf length_hours2 > 1 AND length_min = 0 Then
			Minutes = length_hours2 & " timer tilbage"
			
		ElseIf length_hours2 = 1 AND length_min > 1 Then
			Minutes = length_hours2 & " time og " & length_min & " minutter tilbage"
		ElseIf length_hours2 = 1 AND length_min = 1  Then
			Minutes = length_hours2 & " time og " & length_min & " minut tilbage"
		ElseIf length_hours2 = 1 AND length_min = 0 Then
			Minutes = length_hours2 & " time tilbage"
					
		ElseIf length_hours2 = 0 AND length_min > 1 Then
			Minutes = length_min & " minutter tilbage"
		ElseIf length_hours2 = 0 AND length_min = 1  Then
			Minutes = length_min & " minut tilbage"
		ElseIf length_hours2 = 0 AND length_min = 0 Then
			Minutes = "Udsendelse er forbi"
		
		Else
			Minutes = "ERROR"
		End If
		
		Select Case Enhed
		
		Case "%"	result = Procent
		Case "MIN"	result = Minutes
		Case "min"	result = Minutes
		Case "Min"	result = Minutes
		Case Else	result = "Forket Enhed"
		
		End Select
		
		CompareTime = result
	End If
End Function


Private Function GetHTMLBin(strURL) 

	Dim objXMLHTTP, strReturn 

	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", strURL, False 
	objXMLHTTP.Send
	
	GetHTMLBin = objXMLHTTP.responseBody 
	Set objXMLHTTP = Nothing 

End Function 


Private Function BinToText(varBinData, intDataSizeInBytes)

	Dim objRs 
	Const adFldLong = &H00000080 
	Const adVarChar = 200 
	
	Set objRS = CreateObject("ADODB.Recordset") 
	
	objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong 
	objRS.Open 
	
	objRS.AddNew 
	objRS.Fields("txt").AppendChunk varBinData 
	BinToText = objRS("txt").Value 
	
	objRS.Close 
	
	Set objRS = Nothing 

End Function


Private Function DateLastModified(Kanal)

	Dim fs,f,datemod
	
	file = GetTempPath & "TVGuide_" & Kanal & ".txt"
 	Set fs=CreateObject("Scripting.FileSystemObject")
 	If fs.fileexists(file) Then
 		Set f=fs.GetFile(file)
 		datemod1 = f.DateLastModified
 		datemod = Left(datemod1, 10)
 	Else
 		datemod = 01-01-2001
	End If
	Set f=nothing
	Set fs=nothing
	DateLastModified = datemod

End Function
